/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import org.threeten.bp.LocalDate;

import java.util.Objects;

/**
 * Information related to the advertised price.
 */
@ApiModel(description = "Information related to the advertised price.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class AdvertisedPrice {
  @SerializedName("discovery_date")
  private LocalDate discoveryDate = null;

  @SerializedName("publishing_location")
  private String publishingLocation = null;

  @SerializedName("retail_name")
  private String retailName = null;

  @SerializedName("price")
  private Model121 price = null;

  public AdvertisedPrice discoveryDate(LocalDate discoveryDate) {
    this.discoveryDate = discoveryDate;
    return this;
  }

   /**
   * Date the advertisement with the new price was discovered by the customer. ISO 8601 format (YYYY-MM-DD).
   * @return discoveryDate
  **/
  @ApiModelProperty(value = "Date the advertisement with the new price was discovered by the customer. ISO 8601 format (YYYY-MM-DD).")
  public LocalDate getDiscoveryDate() {
    return discoveryDate;
  }

  public void setDiscoveryDate(LocalDate discoveryDate) {
    this.discoveryDate = discoveryDate;
  }

  public AdvertisedPrice publishingLocation(String publishingLocation) {
    this.publishingLocation = publishingLocation;
    return this;
  }

   /**
   * Location where the advertisement has been observed and the name of the publication.
   * @return publishingLocation
  **/
  @ApiModelProperty(example = "Newspaper", value = "Location where the advertisement has been observed and the name of the publication.")
  public String getPublishingLocation() {
    return publishingLocation;
  }

  public void setPublishingLocation(String publishingLocation) {
    this.publishingLocation = publishingLocation;
  }

  public AdvertisedPrice retailName(String retailName) {
    this.retailName = retailName;
    return this;
  }

   /**
   * Name of the brand, store or website where the price was cheaper than the purchased one.
   * @return retailName
  **/
  @ApiModelProperty(value = "Name of the brand, store or website where the price was cheaper than the purchased one.")
  public String getRetailName() {
    return retailName;
  }

  public void setRetailName(String retailName) {
    this.retailName = retailName;
  }

  public AdvertisedPrice price(Model121 price) {
    this.price = price;
    return this;
  }

   /**
   * Get price
   * @return price
  **/
  @ApiModelProperty(value = "")
  public Model121 getPrice() {
    return price;
  }

  public void setPrice(Model121 price) {
    this.price = price;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    AdvertisedPrice advertisedPrice = (AdvertisedPrice) o;
    return Objects.equals(this.discoveryDate, advertisedPrice.discoveryDate) &&
        Objects.equals(this.publishingLocation, advertisedPrice.publishingLocation) &&
        Objects.equals(this.retailName, advertisedPrice.retailName) &&
        Objects.equals(this.price, advertisedPrice.price);
  }

  @Override
  public int hashCode() {
    return Objects.hash(discoveryDate, publishingLocation, retailName, price);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class AdvertisedPrice {\n");
    
    sb.append("    discoveryDate: ").append(toIndentedString(discoveryDate)).append("\n");
    sb.append("    publishingLocation: ").append(toIndentedString(publishingLocation)).append("\n");
    sb.append("    retailName: ").append(toIndentedString(retailName)).append("\n");
    sb.append("    price: ").append(toIndentedString(price)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

